---
product: "AG Grid"
title: "Grid Lifecycle"
description: "This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed."
framework: javascript
version: "36.2.0"
related:
    - title: "Grid State"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-state/"
    - title: "Grid Context"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/context/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Lifecycle

This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed.

> **Note**
>
> The events on this page are listed in the order they are raised.

## Grid Ready

The `gridReady` event fires upon grid initialisation but the grid may not be fully rendered.

**Common Uses**

- Customising Grid via API calls.
- Event listener setup.
- Grid-dependent setup code.

In this example, `gridReady` applies user pinning preferences before rendering data.

#### Using Grid Ready Event

```ts
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { TAthlete, getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ColumnApiModule, ClientSideRowModelModule]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "name", headerName: "Athlete", width: 250 },
    { field: "person.country", headerName: "Country" },
    { field: "person.age", headerName: "Age" },
    { field: "medals.gold", headerName: "Gold Medals" },
    { field: "medals.silver", headerName: "Silver Medals" },
    { field: "medals.bronze", headerName: "Bronze Medals" },
  ],
  rowData: getData(),
  onGridReady: (params: GridReadyEvent<TAthlete>) => {
    const checkbox = document.querySelector<HTMLInputElement>(
      "#pinFirstColumnOnLoad",
    )!;
    const shouldPinFirstColumn = checkbox && checkbox.checked;
    if (shouldPinFirstColumn) {
      params.api.applyColumnState({
        state: [{ colId: "name", pinned: "left" }],
      });
    }
  },
};

function reloadGrid() {
  if (gridApi) {
    gridApi.destroy();
  }

  setTimeout(() => {
    // Artificial delay to show grid being destroyed and re-created
    const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
    gridApi = createGrid(gridDiv, gridOptions);
  }, 500);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).reloadGrid = reloadGrid;
}
```

[Live example: Using Grid Ready Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/grid-ready/typescript/)

## First Data Rendered

The `firstDataRendered` event fires the first time data is rendered into the grid. It will only be fired once unlike `rowDataUpdated` which is fired on every data change.

## Row Data Updated

The `rowDataUpdated` event fires every time the grid's data changes, by [Updating Row Data](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/data-update-row-data/) or by applying [Transaction Updates](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/data-update-transactions/). In the [Server Side Row Model](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/server-side-model/), use the [Model Updated Event](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-events/#reference-gridLifecycle-modelUpdated) instead.

In this example the time at which `firstDataRendered` and `rowDataUpdated` are fired is recorded above the grid. Note that `firstDataRendered` is only set on the initial load of the grid and is not updated when reloading data.

#### Using Row Data Event

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowDataUpdatedEvent,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { TAthlete, fetchDataAsync } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

const updateRowCount = (id: string) => {
  const element = document.querySelector(`#${id} > .value`);
  element!.textContent = `${new Date().toLocaleTimeString()}`;
};

const setBtnReloadDataDisabled = (disabled: boolean) => {
  (document.getElementById("btnReloadData") as HTMLButtonElement).disabled =
    disabled;
};

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "name", headerName: "Athlete" },
    { field: "person.age", headerName: "Age" },
    { field: "medals.gold", headerName: "Gold Medals" },
  ],
  loading: true,
  onFirstDataRendered: (event: FirstDataRenderedEvent) => {
    updateRowCount("firstDataRendered");
    console.log("First Data Rendered");
  },
  onRowDataUpdated: (event: RowDataUpdatedEvent<TAthlete>) => {
    updateRowCount("rowDataUpdated");
    console.log("Row Data Updated");
  },
  onGridReady: () => {
    console.log("Loading Data ...");
    fetchDataAsync()
      .then((data) => {
        console.log("Data Loaded");
        gridApi!.setGridOption("rowData", data);
      })
      .catch((error) => {
        console.error("Failed to load data", error);
      })
      .finally(() => {
        gridApi!.setGridOption("loading", false);
        setBtnReloadDataDisabled(false);
      });
  },
};

function onBtnReloadData() {
  console.log("Reloading Data ...");
  setBtnReloadDataDisabled(true);
  gridApi!.setGridOption("loading", true);
  fetchDataAsync()
    .then((data) => {
      console.log("Data Reloaded");
      gridApi!.setGridOption("rowData", data);
    })
    .catch((error) => {
      console.error("Failed to reload data", error);
    })
    .finally(() => {
      gridApi!.setGridOption("loading", false);
      setBtnReloadDataDisabled(false);
    });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtnReloadData = onBtnReloadData;
}
```

[Live example: Using Row Data Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/row-data-updated/typescript/)

## Grid Pre-Destroyed

The `gridPreDestroyed` event fires just before the grid is destroyed and is removed from the DOM.

**Common Uses**

- Clean up resources.
- Save grid state.
- Disconnect other libraries.

The [Grid State Example](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-state/#saving-and-restoring-state) demonstrates how `gridPreDestroyed` can be used to save and restore grid state.


---
product: "AG Grid"
title: "Grid Lifecycle"
description: "This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed."
framework: angular
version: "36.2.0"
related:
    - title: "Grid State"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-state/"
    - title: "Grid Context"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/context/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Lifecycle

This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed.

> **Note**
>
> The events on this page are listed in the order they are raised.

## Grid Ready

The `gridReady` event fires upon grid initialisation but the grid may not be fully rendered.

**Common Uses**

- Customising Grid via API calls.
- Event listener setup.
- Grid-dependent setup code.

In this example, `gridReady` applies user pinning preferences before rendering data.

#### Using Grid Ready Event

```ts
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef, GridApi, GridReadyEvent } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ColumnApiModule, ClientSideRowModelModule]);

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="test-container">
      <div class="test-header">
        <div style="margin-bottom: 1rem;">
          <input type="checkbox" id="pinFirstColumnOnLoad" />
          <label for="pinFirstColumnOnLoad">Pin first column on load</label>
        </div>
        <div style="margin-bottom: 1rem;">
          <button id="reloadGridButton" (click)="reloadGrid()">
            Reload Grid
          </button>
        </div>
      </div>
      @if (isVisible) {
        <ag-grid-angular
          style="width: 100%; height: 100%;"
          [columnDefs]="columnDefs"
          [rowData]="rowData"
          (gridReady)="onGridReady($event)"
        />
      }
    </div>
  `,
})
export class AppComponent {
  public isVisible = true;
  private gridApi!: GridApi;
  public columnDefs: ColDef[] = [
    { field: "name", headerName: "Athlete", width: 250 },
    { field: "person.country", headerName: "Country" },
    { field: "person.age", headerName: "Age" },
    { field: "medals.gold", headerName: "Gold Medals" },
    { field: "medals.silver", headerName: "Silver Medals" },
    { field: "medals.bronze", headerName: "Bronze Medals" },
  ];

  public rowData: any[] | null = getData();

  reloadGrid() {
    this.isVisible = false;
    setTimeout(() => (this.isVisible = true), 1);
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
    const checkbox = document.querySelector<HTMLInputElement>(
      "#pinFirstColumnOnLoad",
    )!;
    const shouldPinFirstColumn = checkbox && checkbox.checked;
    if (shouldPinFirstColumn) {
      params.api.applyColumnState({
        state: [{ colId: "name", pinned: "left" }],
      });
    }
  }
}
```

[Live example: Using Grid Ready Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/grid-ready/angular/)

## First Data Rendered

The `firstDataRendered` event fires the first time data is rendered into the grid. It will only be fired once unlike `rowDataUpdated` which is fired on every data change.

## Row Data Updated

The `rowDataUpdated` event fires every time the grid's data changes, by [Updating Row Data](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/data-update-row-data/) or by applying [Transaction Updates](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/data-update-transactions/). In the [Server Side Row Model](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/server-side-model/), use the [Model Updated Event](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-events/#reference-gridLifecycle-modelUpdated) instead.

In this example the time at which `firstDataRendered` and `rowDataUpdated` are fired is recorded above the grid. Note that `firstDataRendered` is only set on the initial load of the grid and is not updated when reloading data.

#### Using Row Data Event

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowDataUpdatedEvent,
  enableDevValidations,
} from "ag-grid-community";
import { TAthlete, fetchDataAsync } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-container">
    <div class="test-header">
      <div id="firstDataRendered">
        First Data Rendered: <span class="value">-</span>
      </div>
      <div id="rowDataUpdated">
        Row Data Updated: <span class="value">-</span>
      </div>
      <div>
        <button id="btnReloadData" (click)="onBtnReloadData()">
          Reload Data
        </button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [loading]="true"
      [rowData]="rowData"
      (firstDataRendered)="onFirstDataRendered($event)"
      (rowDataUpdated)="onRowDataUpdated($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "name", headerName: "Athlete" },
    { field: "person.age", headerName: "Age" },
    { field: "medals.gold", headerName: "Gold Medals" },
  ];
  rowData!: any[];

  onFirstDataRendered(event: FirstDataRenderedEvent) {
    updateRowCount("firstDataRendered");
    console.log("First Data Rendered");
  }

  onRowDataUpdated(event: RowDataUpdatedEvent<TAthlete>) {
    updateRowCount("rowDataUpdated");
    console.log("Row Data Updated");
  }

  onBtnReloadData() {
    console.log("Reloading Data ...");
    setBtnReloadDataDisabled(true);
    this.gridApi.setGridOption("loading", true);
    fetchDataAsync()
      .then((data) => {
        console.log("Data Reloaded");
        this.gridApi.setGridOption("rowData", data);
      })
      .catch((error) => {
        console.error("Failed to reload data", error);
      })
      .finally(() => {
        this.gridApi.setGridOption("loading", false);
        setBtnReloadDataDisabled(false);
      });
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    console.log("Loading Data ...");
    fetchDataAsync()
      .then((data) => {
        console.log("Data Loaded");
        params.api!.setGridOption("rowData", data);
      })
      .catch((error) => {
        console.error("Failed to load data", error);
      })
      .finally(() => {
        params.api!.setGridOption("loading", false);
        setBtnReloadDataDisabled(false);
      });
  }
}

const updateRowCount = (id: string) => {
  const element = document.querySelector(`#${id} > .value`);
  element!.textContent = `${new Date().toLocaleTimeString()}`;
};
const setBtnReloadDataDisabled = (disabled: boolean) => {
  (document.getElementById("btnReloadData") as HTMLButtonElement).disabled =
    disabled;
};
```

[Live example: Using Row Data Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/row-data-updated/angular/)

## Grid Pre-Destroyed

The `gridPreDestroyed` event fires just before the grid is destroyed and is removed from the DOM.

**Common Uses**

- Clean up resources.
- Save grid state.
- Disconnect other libraries.

The [Grid State Example](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-state/#saving-and-restoring-state) demonstrates how `gridPreDestroyed` can be used to save and restore grid state.

### Angular PreDestroy Setup

When using Angular, the `gridPreDestroyed` event handler must be registered via grid options instead of as an Output event handler to work correctly.

For example:

```js
this.gridOptions = {
    onGridPreDestroyed: () => {
        // handler code
    }
};
```


---
product: "AG Grid"
title: "Grid Lifecycle"
description: "This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed."
framework: vue
version: "36.2.0"
related:
    - title: "Grid State"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-state/"
    - title: "Grid Context"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/context/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Lifecycle

This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed.

> **Note**
>
> The events on this page are listed in the order they are raised.

## Grid Ready

The `gridReady` event fires upon grid initialisation but the grid may not be fully rendered.

**Common Uses**

- Customising Grid via API calls.
- Event listener setup.
- Grid-dependent setup code.

In this example, `gridReady` applies user pinning preferences before rendering data.

#### Using Grid Ready Event

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";

import type { ColDef, GridApi, GridReadyEvent } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ColumnApiModule, ClientSideRowModelModule]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
            <div class="test-container">
                <div class="test-header">
                    <div style="margin-bottom: 1rem;">
                        <input type="checkbox" id="pinFirstColumnOnLoad">
                        <label for="pinFirstColumnOnLoad">Pin first column on load</label>
                    </div>
                    <div style="margin-bottom: 1rem;">
                        <button id="reloadGridButton" v-on:click="reloadGrid()">Reload Grid</button>
                    </div>
                </div>
                <ag-grid-vue
                    v-if="isVisible"              
                    style="width: 100%; height: 100%;"
                    :columnDefs="columnDefs"
                    @grid-ready="onGridReady"
                    :rowData="rowData"></ag-grid-vue>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const columnDefs = ref<ColDef[]>([
      {
        field: "name",
        headerName: "Athlete",
        width: 250,
      },
      {
        field: "person.country",
        headerName: "Country",
      },
      {
        field: "person.age",
        headerName: "Age",
      },
      {
        field: "medals.gold",
        headerName: "Gold Medals",
      },
      {
        field: "medals.silver",
        headerName: "Silver Medals",
      },
      {
        field: "medals.bronze",
        headerName: "Bronze Medals",
      },
    ]);

    const gridApi = shallowRef<GridApi | null>(null);

    const rowData = ref<any[]>(null);
    const isVisible = ref(true);

    onBeforeMount(() => {
      rowData.value = getData();
    });

    const reloadGrid = () => {
      isVisible.value = false;
      setTimeout(() => (isVisible.value = true), 1);
    };
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const checkbox = document.querySelector("#pinFirstColumnOnLoad");
      const shouldPinFirstColumn = checkbox && checkbox.checked;

      if (shouldPinFirstColumn) {
        params.api.applyColumnState({
          state: [{ colId: "name", pinned: "left" }],
        });
      }
    };

    return {
      columnDefs,
      gridApi,
      rowData,
      onGridReady,
      reloadGrid,
      isVisible,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Using Grid Ready Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/grid-ready/vue3/)

## First Data Rendered

The `firstDataRendered` event fires the first time data is rendered into the grid. It will only be fired once unlike `rowDataUpdated` which is fired on every data change.

## Row Data Updated

The `rowDataUpdated` event fires every time the grid's data changes, by [Updating Row Data](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/data-update-row-data/) or by applying [Transaction Updates](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/data-update-transactions/). In the [Server Side Row Model](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/server-side-model/), use the [Model Updated Event](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-events/#reference-gridLifecycle-modelUpdated) instead.

In this example the time at which `firstDataRendered` and `rowDataUpdated` are fired is recorded above the grid. Note that `firstDataRendered` is only set on the initial load of the grid and is not updated when reloading data.

#### Using Row Data Event

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowDataUpdatedEvent,
  enableDevValidations,
} from "ag-grid-community";
import { TAthlete } from "./data";
import { fetchDataAsync } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

const updateRowCount = (id: string) => {
  const element = document.querySelector(`#${id} > .value`);
  element!.textContent = `${new Date().toLocaleTimeString()}`;
};

const setBtnReloadDataDisabled = (disabled: boolean) => {
  (document.getElementById("btnReloadData") as HTMLButtonElement).disabled =
    disabled;
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <div id="firstDataRendered">First Data Rendered: <span class="value">-</span></div>
        <div id="rowDataUpdated">Row Data Updated: <span class="value">-</span></div>
        <div>
          <button id="btnReloadData" v-on:click="onBtnReloadData()">Reload Data</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :loading="true"
        :rowData="rowData"
        @first-data-rendered="onFirstDataRendered"
        @row-data-updated="onRowDataUpdated"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "name", headerName: "Athlete" },
      { field: "person.age", headerName: "Age" },
      { field: "medals.gold", headerName: "Gold Medals" },
    ]);
    const rowData = ref<any[]>(null);

    function onFirstDataRendered(event: FirstDataRenderedEvent) {
      updateRowCount("firstDataRendered");
      console.log("First Data Rendered");
    }
    function onRowDataUpdated(event: RowDataUpdatedEvent<TAthlete>) {
      updateRowCount("rowDataUpdated");
      console.log("Row Data Updated");
    }
    function onBtnReloadData() {
      console.log("Reloading Data ...");
      setBtnReloadDataDisabled(true);
      gridApi.value!.setGridOption("loading", true);
      fetchDataAsync()
        .then((data) => {
          console.log("Data Reloaded");
          gridApi.value!.setGridOption("rowData", data);
        })
        .catch((error) => {
          console.error("Failed to reload data", error);
        })
        .finally(() => {
          gridApi.value!.setGridOption("loading", false);
          setBtnReloadDataDisabled(false);
        });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      console.log("Loading Data ...");
      fetchDataAsync()
        .then((data) => {
          console.log("Data Loaded");
          params.api!.setGridOption("rowData", data);
        })
        .catch((error) => {
          console.error("Failed to load data", error);
        })
        .finally(() => {
          params.api!.setGridOption("loading", false);
          setBtnReloadDataDisabled(false);
        });
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      onGridReady,
      onFirstDataRendered,
      onRowDataUpdated,
      onBtnReloadData,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Using Row Data Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/row-data-updated/vue3/)

## Grid Pre-Destroyed

The `gridPreDestroyed` event fires just before the grid is destroyed and is removed from the DOM.

**Common Uses**

- Clean up resources.
- Save grid state.
- Disconnect other libraries.

The [Grid State Example](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-state/#saving-and-restoring-state) demonstrates how `gridPreDestroyed` can be used to save and restore grid state.


---
product: "AG Grid"
title: "Grid Lifecycle"
description: "This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed."
framework: react
version: "36.2.0"
related:
    - title: "Grid State"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-state/"
    - title: "Grid Context"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/context/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Lifecycle

This section covers some common lifecycle events that are raised after grid initialisation, data updates, and before the grid is destroyed.

> **Note**
>
> The events on this page are listed in the order they are raised.

## Grid Ready

The `gridReady` event fires upon grid initialisation but the grid may not be fully rendered.

**Common Uses**

- Customising Grid via API calls.
- Event listener setup.
- Grid-dependent setup code.

In this example, `gridReady` applies user pinning preferences before rendering data.

#### Using Grid Ready Event

```tsx
'use client';
import React, {
  StrictMode,
  useCallback,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ColumnApiModule, ClientSideRowModelModule];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const [gridKey, setGridKey] = useState<string>(`grid-key-${window.agRandom()}`);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "name", headerName: "Athlete", width: 250 },
    { field: "person.country", headerName: "Country" },
    { field: "person.age", headerName: "Age" },
    { field: "medals.gold", headerName: "Gold Medals" },
    { field: "medals.silver", headerName: "Silver Medals" },
    { field: "medals.bronze", headerName: "Bronze Medals" },
  ]);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    const checkbox = document.querySelector<HTMLInputElement>(
      "#pinFirstColumnOnLoad",
    )!;
    const shouldPinFirstColumn = checkbox && checkbox.checked;
    if (shouldPinFirstColumn) {
      params.api.applyColumnState({
        state: [{ colId: "name", pinned: "left" }],
      });
    }
  }, []);

  const reloadGrid = useCallback(() => {
    // Trigger re-load by assigning a new key to the Grid React component
    setGridKey(`grid-key-${window.agRandom()}`);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <div style={{ marginBottom: "1rem" }}>
              <input type="checkbox" id="pinFirstColumnOnLoad" />
              <label htmlFor="pinFirstColumnOnLoad">
                Pin first column on load
              </label>
            </div>

            <div style={{ marginBottom: "1rem" }}>
              <button id="reloadGridButton" onClick={reloadGrid}>
                Reload Grid
              </button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              key={gridKey}
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              onGridReady={onGridReady}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Using Grid Ready Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/grid-ready/reactFunctionalTs/)

## First Data Rendered

The `firstDataRendered` event fires the first time data is rendered into the grid. It will only be fired once unlike `rowDataUpdated` which is fired on every data change.

## Row Data Updated

The `rowDataUpdated` event fires every time the grid's data changes, by [Updating Row Data](https://www.ag-grid.com/archive/36.2.0/react-data-grid/data-update-row-data/) or by applying [Transaction Updates](https://www.ag-grid.com/archive/36.2.0/react-data-grid/data-update-transactions/). In the [Server Side Row Model](https://www.ag-grid.com/archive/36.2.0/react-data-grid/server-side-model/), use the [Model Updated Event](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-events/#reference-gridLifecycle-modelUpdated) instead.

In this example the time at which `firstDataRendered` and `rowDataUpdated` are fired is recorded above the grid. Note that `firstDataRendered` is only set on the initial load of the grid and is not updated when reloading data.

#### Using Row Data Event

```tsx
'use client';
import React, { StrictMode, useCallback, useEffect, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import type {
  FirstDataRenderedEvent,
  RowDataUpdatedEvent,
} from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import { fetchDataAsync } from "./data";
import type { TAthlete } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

const updateRowCount = (id: string) => {
  const element = document.querySelector(`#${id} > .value`);
  element!.textContent = `${new Date().toLocaleTimeString()}`;
};

const columnDefs = [
  { field: "name", headerName: "Athlete" },
  { field: "person.age", headerName: "Age" },
  { field: "medals.gold", headerName: "Gold Medals" },
];

const GridExample = () => {
  const [loading, setLoading] = useState<boolean>(true);
  const [rowData, setRowData] = useState<TAthlete[] | undefined>();

  const onFirstDataRendered = useCallback((event: FirstDataRenderedEvent) => {
    updateRowCount("firstDataRendered");
    console.log("First Data Rendered");
  }, []);

  const onRowDataUpdated = useCallback(
    (event: RowDataUpdatedEvent<TAthlete>) => {
      updateRowCount("rowDataUpdated");
      console.log("Row Data Updated");
    },
    [],
  );

  const reloadData = useCallback(() => {
    console.log("Loading Data ...");
    setLoading(true);
    fetchDataAsync()
      .then((data) => {
        console.info("Data Loaded");
        setRowData(data);
      })
      .catch((error) => {
        console.error("Failed to load data", error);
      })
      .finally(() => {
        setLoading(false);
      });
  }, []);

  useEffect(reloadData, []);

  return (
    <AgGridProvider modules={modules}>
      <div className="test-container">
        <div className="test-header">
          <div id="firstDataRendered">
            First Data Rendered: <span className="value">-</span>
          </div>
          <div id="rowDataUpdated">
            Row Data Updated: <span className="value">-</span>
          </div>
          <div>
            <button disabled={loading} onClick={reloadData}>
              Reload Data
            </button>
          </div>
        </div>

        <div style={{ height: "100%" }}>
          <AgGridReact
            loading={loading}
            rowData={rowData}
            columnDefs={columnDefs}
            onFirstDataRendered={onFirstDataRendered}
            onRowDataUpdated={onRowDataUpdated}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Using Row Data Event](https://www.ag-grid.com/archive/36.2.0/examples/grid-lifecycle/row-data-updated/reactFunctionalTs/)

## Grid Pre-Destroyed

The `gridPreDestroyed` event fires just before the grid is destroyed and is removed from the DOM.

**Common Uses**

- Clean up resources.
- Save grid state.
- Disconnect other libraries.

The [Grid State Example](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-state/#saving-and-restoring-state) demonstrates how `gridPreDestroyed` can be used to save and restore grid state.
